/*
    ggcap - libgg80.h
    (patch for GG80 protocol)

    Copyright (c) 2009 Arkadiusz Bokowy
    Thanks to libgadu-devel team
*/

#ifndef __LIBGADU_80
#define __LIBGADU_80

#include <unistd.h>

//overwrite libgadu.h descr max size value to x80 standard
#undef GG_STATUS_DESCR_MAXSIZE
#define GG_STATUS_DESCR_MAXSIZE 255

#define GG_NEW_STATUS80 0x0038
struct gg_new_status80 {
	uint32_t status;
	uint32_t flags;
	uint32_t description_size;
//	char description[]; //NOT NULL-terminated
};

#define GG_USER_BUDDY 0x01
#define GG_USER_FRIEND 0x02
#define GG_USER_BLOCKED 0x04

#define GG_STATUS80 0x0036
#define GG_NOTIFY_REPLY80 0x0037
struct gg_status80 {
	uint32_t uin;
	uint32_t status;
	uint32_t flags;
	uint32_t remote_ip;
	uint16_t remote_port;
	uint8_t image_size;
	uint8_t unknown2;
	uint32_t unknown3;
	uint32_t description_size;
//	char description[]; //NOT NULL-terminated
};

#define GG_STATUS80_GDESCR_MASK 0x0100 /* graphical description mask */
#define GG_STATUS80_DESCR_MASK 0x4000 /* description mask */

#define GG_S80(x) (GG_S(x) & ~(GG_STATUS80_GDESCR_MASK + GG_STATUS80_DESCR_MASK))
#define GG_S80_D(x) (((x) & GG_STATUS80_DESCR_MASK) != 0)
#define GG_S80_GD(x) (((x) & GG_STATUS80_GDESCR_MASK) != 0)

#define GG_SEND_MSG80 0x002d
struct gg_send_msg80 {
	uint32_t recipient;
	uint32_t seq;
	uint32_t msgclass;
	uint32_t offset_plain;
	uint32_t offset_attributes;
//	char html_message[];  //NULL-termaniated
//	char plain_message[]; //NULL-termaniated
//	char attributes[];
};

#define GG_RECV_MSG80 0x002e
struct gg_recv_msg80 {
	uint32_t sender;
	uint32_t seq;
	uint32_t time;
	uint32_t msgclass;
	uint32_t offset_plain;
	uint32_t offset_attributes;
//	char html_message[];  //NULL-termaniated
//	char plain_message[]; //NULL-termaniated
//	char attributes[];
};

#define GG_LOGIN80 0x0031
struct gg_login80 {
	uint32_t uin;
	char language[2];
	uint8_t hash_type;
	uint8_t hash[64];
	uint32_t status;
	uint32_t flags;
	uint32_t features;
	uint32_t local_ip;
	uint16_t local_port;
	uint32_t external_ip;
	uint16_t external_port;
	uint8_t image_size;
	char unknown2;
//	uint32_t version_len;
//	char version[]; //NOT NULL-terminated
//	uint32_t description_size;
//	char description[]; //NOT NULL-terminated
};

#define GG_LOGIN80_OK 0x0035

#endif
